package pku_softeng;

import java.util.IdentityHashMap;
import java.util.Stack;

public class CalculateMemoVisitor implements MemoVisitor {
    public Stack<Integer> values = new Stack<>();

    private IdentityHashMap<Expression, Integer> cache = new IdentityHashMap<>();

    @Override
    public void visit(Add a) {
        a.left.accept(this);  
        a.right.accept(this); 
        int result = values.pop() + values.pop();
        values.push(result);
        cache.put(a, result);
    }

    @Override
    public void visit(Sub s) {
        s.left.accept(this);  
        s.right.accept(this); 
        int result = values.pop() - values.pop();
        values.push(result);
        cache.put(s, result);        
    }

    @Override
    public void visit(Number n) {
        values.push((Integer)n.value);
        cache.put(n, (Integer)n.value);  
    }

    @Override
    public boolean alreadyVisited(Expression a) {
        return cache.containsKey(a);
    }

    @Override
    public void visitAgain(Expression a) {
        this.values.push(this.cache.get(a));
    }
    
}
